Index: /branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Lib/HLServiceMembershipProvider.cs
===================================================================
--- /branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Lib/HLServiceMembershipProvider.cs	(revision 5798)
+++ /branches/WebApplication/MVC2/HeuristicLabWeb.PluginHost/HLWebPluginHost/Lib/HLServiceMembershipProvider.cs	(revision 5798)
@@ -0,0 +1,129 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Web;
+
+namespace HLWebPluginHost.Lib {
+  public class HLServiceMembershipProvider : System.Web.Security.MembershipProvider {
+    public override string ApplicationName {
+      get {
+        throw new NotImplementedException();
+      }
+      set {
+        throw new NotImplementedException();
+      }
+    }
+
+    public override bool ChangePassword(string username, string oldPassword, string newPassword) {
+      throw new NotImplementedException();
+    }
+
+    public override bool ChangePasswordQuestionAndAnswer(string username, string password, string newPasswordQuestion, string newPasswordAnswer) {
+      throw new NotImplementedException();
+    }
+
+    public override System.Web.Security.MembershipUser CreateUser(string username, string password, string email, string passwordQuestion, string passwordAnswer, bool isApproved, object providerUserKey, out System.Web.Security.MembershipCreateStatus status) {
+      throw new NotImplementedException();
+    }
+
+    public override bool DeleteUser(string username, bool deleteAllRelatedData) {
+      throw new NotImplementedException();
+    }
+
+    public override bool EnablePasswordReset {
+      get { throw new NotImplementedException(); }
+    }
+
+    public override bool EnablePasswordRetrieval {
+      get { throw new NotImplementedException(); }
+    }
+
+    public override System.Web.Security.MembershipUserCollection FindUsersByEmail(string emailToMatch, int pageIndex, int pageSize, out int totalRecords) {
+      throw new NotImplementedException();
+    }
+
+    public override System.Web.Security.MembershipUserCollection FindUsersByName(string usernameToMatch, int pageIndex, int pageSize, out int totalRecords) {
+      throw new NotImplementedException();
+    }
+
+    public override System.Web.Security.MembershipUserCollection GetAllUsers(int pageIndex, int pageSize, out int totalRecords) {
+      throw new NotImplementedException();
+    }
+
+    public override int GetNumberOfUsersOnline() {
+      throw new NotImplementedException();
+    }
+
+    public override string GetPassword(string username, string answer) {
+      throw new NotImplementedException();
+    }
+
+    public override System.Web.Security.MembershipUser GetUser(string username, bool userIsOnline) {
+      throw new NotImplementedException();
+    }
+
+    public override System.Web.Security.MembershipUser GetUser(object providerUserKey, bool userIsOnline) {
+      throw new NotImplementedException();
+    }
+
+    public override string GetUserNameByEmail(string email) {
+      throw new NotImplementedException();
+    }
+
+    public override int MaxInvalidPasswordAttempts {
+      get { throw new NotImplementedException(); }
+    }
+
+    public override int MinRequiredNonAlphanumericCharacters {
+      get { throw new NotImplementedException(); }
+    }
+
+    public override int MinRequiredPasswordLength {
+      get { throw new NotImplementedException(); }
+    }
+
+    public override int PasswordAttemptWindow {
+      get { throw new NotImplementedException(); }
+    }
+
+    public override System.Web.Security.MembershipPasswordFormat PasswordFormat {
+      get { throw new NotImplementedException(); }
+    }
+
+    public override string PasswordStrengthRegularExpression {
+      get { throw new NotImplementedException(); }
+    }
+
+    public override bool RequiresQuestionAndAnswer {
+      get { throw new NotImplementedException(); }
+    }
+
+    public override bool RequiresUniqueEmail {
+      get { throw new NotImplementedException(); }
+    }
+
+    public override string ResetPassword(string username, string answer) {
+      throw new NotImplementedException();
+    }
+
+    public override bool UnlockUser(string userName) {
+      throw new NotImplementedException();
+    }
+
+    public override void UpdateUser(System.Web.Security.MembershipUser user) {
+      throw new NotImplementedException();
+    }
+
+    public override bool ValidateUser(string username, string password) {
+      // Return just true for now as the OKB application works exactly like that
+      // TODO: Add authentication against the HL-Service as soon as it's available.
+      try {
+        HttpContext.Current.Session["Username"] = username;
+        HttpContext.Current.Session["Password"] = password;
+        return true;
+      } catch (Exception) {
+        return false;
+      }
+    }
+  }
+}